lm.component('homeBoxTodo', {
	templateUrl: 'comp/homebox/homeBoxTodo.' + lmCacheTag + 'html',
	bindings: {
		box: '<'
	},
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
		
		ctrl.error = null;
		ctrl.items = [];
		
		ctrl.loadItems = function() {
			$http.get(lmBase.url + 't/items/list',{params : {lid:ctrl.box.labelID}}).then(
				function success(resp) {
					ctrl.items = resp.data;
				},
				function error(resp) {
					ctrl.error = "Error fetching todos. Label has been deleted or access denied.";
				}
			);
		}

		ctrl.itemCreateName = '';

		ctrl.itemCreate = function() {
			var req = {name: ctrl.itemCreateName, labelId: ctrl.box.labelID};
			$http.post(lmBase.url + 't/item',req).then(
				function success(resp) {
					ctrl.itemCreateName = '';
					ctrl.loadItems();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		}
		
		ctrl.itemToggle = function(valueItem) {
			$http.post(lmBase.url + 't/item/' + valueItem.id + '/toggle',!valueItem.done).then(
				function success(resp) {},
				function error(resp) {
					valueItem.done = !valueItem.done;
					serviceLimboMedia.handleHttpErrorNew(resp);
				}
			);
		};
		
		ctrl.$onInit = function() {
			if(ctrl.box.type != 'todoBox') return;
			ctrl.loadItems();
		};		
		
	}
});