lm.component('pageAppPdf', {
  templateUrl: 'comp/page/pageAppPdf.' + lmCacheTag + 'html',
  bindings: {
	  
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($scope, $element, $http,serviceLimboMedia,serviceNotification,serviceDeps) {
	  var ctrl = this;
	  
	  ctrl.blockSize = 10;
	  
	  ctrl.loaded = false;
	  ctrl.file = null;
	  
	  ctrl.pdf = null;
	  ctrl.pages = 0;
	  ctrl.blocks = 0;
	  
	  // state
	  ctrl.block = 0;
	  ctrl.pdfPages = [];
	  ctrl.pageFirstOf = 0;
	  ctrl.pageLastOf = 0;
	  
	  /* settings */
	  ctrl.settings = {};
	  
	  ctrl.vmodes = ['SCALE_DEFAULT','SCALE_ORIGINAL','SCALE_FULL'];
	  ctrl.vmode = ctrl.vmodes[0];
	  
	  ctrl.$postLink = function() {
		  serviceDeps.load("pdf").then(function() {
			  ctrl.loaded = true;
			  ctrl.loadPdf();
		  });
	  };
	  
	  ctrl.$routerOnActivate = function(next) {
		  ctrl.loadFile(next.params.fileId);
	  };
	  
	  ctrl.loadFile = function(fileid) {
			$http.get(lmBase.url + 'f/file/' + fileid + '?details=true').then(
					function success(resp) {
						ctrl.file = resp.data;
						ctrl.loadPdf();
					},
					serviceLimboMedia.handleHttpErrorNew
			);
	  };
	  
	  ctrl.loadPdf = function() {
		  if(!ctrl.loaded || !ctrl.file) return;
		  
		  PDFJS.getDocument(lmBase.url + 'f/stream/' + ctrl.file.id + '/x.pdf').promise.then(
				  ctrl.loadPdfDone,
				  function (reason) {
					  console.error(reason);
				  }
		  );
	  };
	  
	  ctrl.loadPdfDone = function(pdf) {
		  $scope.$apply(function() {
			  ctrl.pdf = pdf;
			  ctrl.pages = ctrl.pdf.numPages;
			  ctrl.blocks = Math.ceil(ctrl.pages / ctrl.blockSize);
			  ctrl.blockLoad(0);
		  });
	  };	  
	  
	  ctrl.blockLoad = function(blockNr) {
		  ctrl.block = blockNr;
		  ctrl.pdfPages = [];
		  
		  ctrl.pageFirstOf = ctrl.block * ctrl.blockSize;
		  ctrl.pageLastOf = ctrl.pageFirstOf + ctrl.blockSize - 1;
		  if(ctrl.pageLastOf >= ctrl.pages) ctrl.pageLastOf = ctrl.pages - 1;
		  
		  var itPage = ctrl.pageFirstOf;
		  while(itPage <= ctrl.pageLastOf) {
			  ctrl.pdf.getPage(++itPage).then(function(page) {
				  $scope.$apply(function() {
					  ctrl.pdfPages[page.pageIndex % ctrl.blockSize] = page;
				  });
			  });
		  }
	  };

	  ctrl.blockPrev = function() {
		  if(ctrl.block > 0) ctrl.blockLoad(ctrl.block - 1);
	  };
	  ctrl.blockNext = function() {
		  if(ctrl.block < (ctrl.blocks - 1)) {
			  ctrl.blockLoad(ctrl.block + 1);
			  window.scrollTo(0, 0);
		  }
	  };
  }
  
});