/* ======================== */
/* = MODULE configuration = */
/* ======================== */
var lm = angular.module('lm', ['ngComponentRouter', 'ngSanitize', 'ngAnimate', 'pascalprecht.translate']);

lm.config(['$httpProvider', function($httpProvider) {

	$httpProvider.defaults.headers.post = {
		'Content-Type' : 'application/json',
		'LM-csrf': 'yeah'
	};

	httpCfgText = {
		headers: { 'Content-Type' : 'text/plain' }
	};

}]);


lm.config(['$translateProvider', function ($translateProvider) {
  
  $translateProvider.useStaticFilesLoader({
	prefix: 'i18n/',
	suffix: '.' + lmCacheTag + 'json'
  });
  
  if(lmLangs && lmLangsMap) {
	  $translateProvider.registerAvailableLanguageKeys(lmLangs, lmLangsMap);
	  $translateProvider.fallbackLanguage(lmLangs[0]);
	  $translateProvider.determinePreferredLanguage();
  }
  else {
	  $translateProvider.fallbackLanguage('en');
	  $translateProvider.preferredLanguage('en');
  }
  
  $translateProvider.useSanitizeValueStrategy('sanitizeParameters');
}]);

lm.config(function($locationProvider) {
	  $locationProvider.html5Mode(false);
	  $locationProvider.hashPrefix('');
});

lm.value('$routerRootComponent', 'lmApp');
