lm.factory('serviceClipboard', [ '$rootScope', '$http', 'serviceNotification' , function($rootScope, $http, serviceNotification) {
	var service = new Object();
	
	/* attributes */
	service.items = [];
	service.working = false;
	
	service.clear = function() {
		service.items = [];
	};
	
	service.reset = function() {
		for(x in service.items) {
			service.items[x].error = null;
		}
	};

	service.clip = function(valueItem) {
		for(x in service.items) {
			if(valueItem.id == service.items[x].value.id) return;
		}

		service.items.push({value: valueItem, error: null});
	};
	
	service.next = function() {
		for(x in service.items) {
			var val = service.items[x];
			if(val.error == null) {
				return val;
			}
		}

		return null;
	};

	service.remove = function(valueItem) {
		for(x in service.items) {
			if(valueItem == service.items[x]) {
				service.items.splice(x,1);
				return;
			}
		}
	};
	
	$rootScope.$on('lmLogout', function() {
		service.clear();
	});
	
	return service;
}]);
